--version 1.1 update
--	removed the killing mobile being passed to the spawner
require 'default:base_mobile'

--backup the DoMobileDeath function so that we can still use
--all the core functions of it while being able to catch
--the Mobile death and make a sort of event out of it.
local BaseDoMobileDeath = DoMobileDeath


--this override allows us to send a message back to the spawner
--telling it we died and it needs to start the next spawn cycle
function DoMobileDeath(damager)
	--pet award owner prestige xp on killing a target
	if not(damager == this) and (damager ~= nil) then	
		damager:SendMessage("VictimKilled", this, damageAmount, damageType)

		if(IsTamedPet(damager)) then
			local master = damager:GetObjVar("controller")
			if(master ~= nil) then
				HandleMobileDeathCheckPrestigeExperience(master, this)
			end
		end
		if ( damager:IsPlayer() ) then
			HandleMobileDeathCheckPrestigeExperience(damager, this)
		end
	end

	--grab the parentSpawner and send the message "mobHasDied"
	if(this:HasObjVar("parentSpawner")) then
		GameObj(this:GetObjVar("parentSpawner")):SendMessage("mobHasDied", this)
	end

	--run all the code in the default:base_mobile:DoMobileDeath(damager)
	BaseDoMobileDeath(damager)
end

