RegisterEventHandler(EventType.Message, "UseObject", 
    function(user,usedType)

        if(usedType == "Set Key") then
            user:SystemMessage("Hog Balls")
            return
        end

        if(usedType == "Lock/Unlock") then
            if(this:GetObjVar("Locked")) then
                this:SetObjVar("Locked",false)
                user:SystemMessage("you unlock the door")
            else
                this:SetObjVar("Locked",true)
                user:SystemMessage("you lock the door")
            end
            this:PlayObjectSound("DoorLock",false)
            return
        end

        if(usedType == "AutoClose Enable/Disable") then
            if(this:GetObjVar("AutoClose")) then
                this:SetObjVar("AutoClose",false)
                user:SystemMessage("you disabled the doors autoclose")
            else
                this:SetObjVar("AutoClose",true)
                user:SystemMessage("you enabled the doors autoclose, starting closed timer")
                CallFunctionDelayed(TimeSpan.FromSeconds(this:GetObjVar("AutoCloseDelay")),
                    function( ... )
                        this:SetSharedObjectProperty("IsOpen", false)
                        this:SetObjVar("IsOpen", false)
                        this:SetCollisionBoundsFromTemplate(this:GetCreationTemplateId())
                    end)                
            end

            --this:PlayObjectSound("DoorLock",false)
            return
        end        

        local hadKey = false
        if(this:GetObjVar("Locked")) then
            local backpackObj = user:GetEquippedObject("Backpack")
            if( backpackObj == nil ) then   
                return false
            else
                local containedObjects = backpackObj:GetContainedObjects()
                for index, containedObj in pairs(containedObjects) do
                    if(containedObj:GetCreationTemplateId() == this:GetObjVar("Key.Template") and hadKey == false) then
                        this:SetObjVar("Locked",false)
                        if(this:GetObjVar("Key.DestroyOnUse")) then
                            user:SystemMessage("you unlock the door, but your key is destroyed in the process.")
                            containedObj:Destroy()
                            this:PlayObjectSound("DoorLock",false)
                        else
                            user:SystemMessage("you unlock the door.. and put away your key.")
                            this:PlayObjectSound("DoorLock",false)                               
                        end
                        hadKey = true
                        OpenDoor()
                    end
                end
            end
            if not(hadKey) then 
                user:SystemMessage("this door seems to be locked..") 
                this:PlayObjectSound("DoorLockPick",false)
            end
        else
            if(this:GetObjVar("IsOpen")) then
                CloseDoor()
            else
                OpenDoor()
            end
        end

    end)

RegisterSingleEventHandler(EventType.ModuleAttached, GetCurrentModule(), 
    function()
        this:SetObjVar("Locked",false)
        this:SetObjVar("IsOpen",false)
        this:SetObjVar("Key.Template","")
        this:SetObjVar("Key.DestroyOnUse",true)
        this:SetObjVar("AutoClose",false)
        this:SetObjVar("AutoCloseDelay",5)
        this:SetObjVar("AutoLock",false)
        this:SetObjVar("AutoLockDelay",5)
        AddUseCase(this,"Set Key",false,{"IsGod"})
        AddUseCase(this,"Lock/Unlock",false,{"IsGod"})
        AddUseCase(this,"AutoClose Enable/Disable")
    end)

function CloseDoor()
    this:SetSharedObjectProperty("IsOpen", false)
    this:SetObjVar("IsOpen", false)
    this:SetCollisionBoundsFromTemplate(this:GetCreationTemplateId())
end
function OpenDoor()
    this:SetSharedObjectProperty("IsOpen", true)
    this:SetObjVar("IsOpen", true)
    this:ClearCollisionBounds()

    if (this:GetObjVar("AutoClose")) then
        CallFunctionDelayed(TimeSpan.FromSeconds(this:GetObjVar("AutoCloseDelay")),
            function( ... )
                this:SetSharedObjectProperty("IsOpen", false)
                this:SetObjVar("IsOpen", false)
                this:SetCollisionBoundsFromTemplate(this:GetCreationTemplateId())
            end)
    end
    
    if (this:GetObjVar("AutoLock")) then
        CallFunctionDelayed(TimeSpan.FromSeconds(this:GetObjVar("AutoLockDelay")),
            function( ... )
                this:SetObjVar("Locked", true)
            end)
    end
end

RegisterEventHandler(EventType.Message,"OpenDoor",OpenDoor)
RegisterEventHandler(EventType.Message,"CloseDoor",CloseDoor)

-- require 'incl_keyhelpers'

-- RegisterEventHandler(EventType.Message, "UseObject", 
--     function(user,usedType)
--         if(usedType == "Open/Close" or usedType == "Open" or usedType == "Close" or usedType == "Use") then 
--             if not(this:HasTimer("OpenCloseDelay")) then
--                 if (this:HasObjVar("OneWay")) then
--                     if (FacingAngleDiff(user,this) > 90) then
--                         user:SystemMessage("The door opens from this direction...")
--                         OpenDoor()
--                         return
--                      end
--                 end
--                 if (this:GetObjVar("locked") ~= nil) then
--                     local key = GetKey(user,this)
--                     if(key) then
--                         user:SystemMessage("That door is locked, but you use the key.")
--                         --Unlock(user,key)
--                         if (key ~= nil) then
--                             if (key:HasObjVar("OneTimeKey")) then
--                                 user:SystemMessage("The key disintegrates.")
--                                 key:Destroy()
--                             end
--                         end
--                     else
--                         user:SystemMessage("That door appears to be locked.")
--                         return
--                     end            
--                 end

--                 local isOpen = this:GetSharedObjectProperty("IsOpen");

--                 if( isOpen ) then
--                     CloseDoor()
--                 else
--                     OpenDoor()
--                 end
--                 this:ScheduleTimerDelay(TimeSpan.FromSeconds(1),"OpenCloseDelay")
--             end
--         elseif(usedType == "Lock") then
--             Lock(user)
--         elseif(usedType == "Unlock") then
--             Unlock(user)
--         end
--     end)

-- function CloseDoor()
--     this:SetSharedObjectProperty("IsOpen", false)
--     this:SetCollisionBoundsFromTemplate(this:GetCreationTemplateId())
--     --DebugMessage("Closing door")
-- end
-- function OpenDoor()
--     this:SetSharedObjectProperty("IsOpen", true)
--     this:ClearCollisionBounds()
--     --DebugMessage("Opening door")
--     if (not this:HasObjVar("NoAutoClose")) then
--         CallFunctionDelayed(TimeSpan.FromSeconds(5),
--             function( ... )
--                 this:SetSharedObjectProperty("IsOpen", false)
--                 this:SetCollisionBoundsFromTemplate(this:GetCreationTemplateId())
--             end)
--     end
    
--     if (this:HasObjVar("AutoLock")) then
--         this:ScheduleTimerDelay(TimeSpan.FromSeconds(10),"AutoLock")
--     end
-- end
-- RegisterEventHandler(EventType.Message,"OpenDoor",OpenDoor)
-- RegisterEventHandler(EventType.Message,"CloseDoor",CloseDoor)

-- function Unlock(user,key)
--     if(user ~= nil and key == nil) then
--         key = GetKey(user,this)
--     end

--     -- user must always have a key!
--     if(user ~= nil and key == nil) then
--         user:SystemMessage("You do not have the proper key to unlock this.")
--         return
--     end

--     this:DelObjVar("locked")
--     if(user ~= nil) then
--         user:SystemMessage("*click*")
--     end

--     this:PlayObjectSound("DoorUnlock")

--     if (key ~= nil) then
--         if (key:HasObjVar("OneTimeKey")) then
--             user:SystemMessage("The key disintegrates.")
--             key:Destroy()
--         end
--     end

--     if (this:HasObjVar("AutoLock")) then
--         this:ScheduleTimerDelay(TimeSpan.FromSeconds(10),"AutoLock")
--     end

--     RemoveTooltipEntry(this,"lock")

--     local houseObj = this:GetObjVar("HouseObject")
--     if(houseObj) then
--         local houseControlObj = GetContainingHouseForObj(this)
--         houseControlObj:SendMessage("DoorUnlocked")
--     end
-- end

-- function Lock(user,key)
--     if(user ~= nil and key == nil) then
--         key = GetKey(user,this)
--     end

--     -- user must always have a key!
--     if(user ~= nil and key == nil) then
--         user:SystemMessage("You do not have the proper key to lock this.")
--         return
--     end

--     this:SetObjVar("locked",true)
--     if(user ~= nil) then
--         user:SystemMessage("*ka-chink*")
--     end
--     this:PlayObjectSound("DoorLock")

--     SetTooltipEntry(this,"lock","[FF0000]*Locked*[-]",10)

--     local houseObj = this:GetObjVar("HouseObject")
--     if(houseObj) then
--         local houseControlObj = GetContainingHouseForObj(this)
--         houseControlObj:SendMessage("DoorLocked")
--     end
-- end

-- function AutoLock()
--     Lock()
--     CloseDoor()
-- end

-- RegisterEventHandler(EventType.Message,"Unlock",Unlock)
-- RegisterEventHandler(EventType.Message,"Activate",Unlock)
-- RegisterEventHandler(EventType.Message,"Lock",Lock)
-- RegisterEventHandler(EventType.Timer,"AutoLock",AutoLock)

-- --make doors lockable from template
-- if (this:HasObjVar("AutoLock")) then
--     Lock(nil,nil)
-- end

-- RegisterSingleEventHandler(EventType.ModuleAttached, "door", 
--     function()
--         AddUseCase(this,"Open/Close",true)
--         AddUseCase(this,"Lock",false,"HasKey")
--         AddUseCase(this,"Unlock",false,"HasKey")
--     end)

-- this:SetObjVar("UseableWhileDead",true)